
cBar = CreateClass()

function cBar:init(px,py,width,border,gfx_base,gfx_inner)
	self.x = px
	self.border = border
	self.y = py
	self.w = width
	self.pos = px
	self.value = 0
	
	self.gfx_base = gfx_base
	self.gfx_inner = gfx_inner
	
	self:setValue(self.value)
end

function cBar:getValue()
	return self.value
end

function cBar:addToValue(add)
	self:setValue(self.value + add)
end

function cBar:setValue(value)
	self.value = math.min(math.max(0, value), 1)	
	self.pos = (self.x + self.border) + self.value  * (self.w - 2 * self.border)
end

function cBar:step()
	
end

function cBar:draw()
	completeScreenOnly()
	
	local w,h = getGfxSourceSize(self.gfx_inner)
	
	simpleDraw(self.gfx_base, self.x, self.y)
	
	local rw = (w - 2*self.border) * self.value
	
	love.graphics.setScissor(self.x, self.y, self.border + rw + 2, h)
	
	simpleDraw(self.gfx_inner, self.x, self.y)
end


