
-- bestimmt die iso tilegroesse
gImg_BaseTile = newPaddedImage("gfx/basetile.png")


gImg_Street = {	newPaddedImage("gfx/tile_street_ns.png"),
				newPaddedImage("gfx/tile_street_we.png")}
				
gImg_Train = {	newPaddedImage("gfx/tile_train_ns.png"),
				newPaddedImage("gfx/tile_train_we.png")}

gImg_BaseTile1 = newPaddedImage("gfx/dec_1.png")
gImg_BaseTile2 = newPaddedImage("gfx/dec_2.png")

gImg_BuildingCommerce1 = newPaddedImage("gfx/com_1.png")
gImg_BuildingCommerce2 = newPaddedImage("gfx/com_2.png")
gImg_BuildingCommerce1_damaged = newPaddedImage("gfx/com_1_damaged.png")
gImg_BuildingCommerce2_damaged = newPaddedImage("gfx/com_2_damaged.png")

gImg_BuildingIndustry1 = newPaddedImage("gfx/ind_1.png")
gImg_BuildingIndustry2 = newPaddedImage("gfx/ind_2.png")
gImg_BuildingIndustry1_damaged = newPaddedImage("gfx/ind_1_damaged.png")
gImg_BuildingIndustry2_damaged = newPaddedImage("gfx/ind_2_damaged.png")

gImg_BuildingResidence1 = newPaddedImage("gfx/res_1.png")
gImg_BuildingResidence2 = newPaddedImage("gfx/res_2.png")
gImg_BuildingResidence1_damaged = newPaddedImage("gfx/res_1_damaged.png")
gImg_BuildingResidence2_damaged = newPaddedImage("gfx/res_2_damaged.png")

gImg_Ground_1 = newPaddedImage("gfx/ground_1.png")
gImg_Ground_2 = newPaddedImage("gfx/ground_2.png")
gImg_Ground_3 = newPaddedImage("gfx/ground_3.png")

gImg_IntroScreen = newPaddedImage("gfx/startscreen.png")
gImg_Schild1Screen = newPaddedImage("gfx/Schild1.png")
gImg_Schild2Screen = newPaddedImage("gfx/Schild2.png")
gImg_GameOverScreen = newPaddedImage("gfx/endscreen.png")

gImg_Grounds = {
	gImg_Ground_1,
	gImg_Ground_1,
	gImg_Ground_1,
	gImg_Ground_1,
	gImg_Ground_1,
	gImg_Ground_1,
	gImg_Ground_2,
	gImg_Ground_2,
	gImg_Ground_2,
	gImg_Ground_3, 
}


gGroundImageCount = table.getn(gImg_Grounds)

gDestroyedImage = {
	[gImg_BuildingIndustry1	] = gImg_BuildingIndustry1_damaged,
	[gImg_BuildingIndustry2		] = gImg_BuildingIndustry2_damaged,
	
	[gImg_BuildingResidence1	] = gImg_BuildingResidence1_damaged,
	[gImg_BuildingResidence2		] = gImg_BuildingResidence2_damaged,
	
	[gImg_BuildingCommerce1	] = gImg_BuildingCommerce1_damaged,
	[gImg_BuildingCommerce2		] = gImg_BuildingCommerce2_damaged,
}

gImg_Explo = newPaddedImage("gfx/explo.png")

gImgGui_City = newPaddedImage("gfx/gui_city.png")

gImgGui_Destroy = newPaddedImage("gfx/gui_destroy.png")

gImg_BarBase = newPaddedImage("gfx/bar_base.png")
gImg_BarInnerRed = newPaddedImage("gfx/bar_inner.png")
gImg_BarInnerBlue = newPaddedImage("gfx/bar_inner_blue.png")
gImg_BarInnerGray = newPaddedImage("gfx/bar_inner_gray.png")

gImg_SliderBase = newPaddedImage("gfx/slider_base.png")
gImg_SliderBaseActive = newPaddedImage("gfx/slider_base_active.png")
gImg_SliderDotRed = newPaddedImage("gfx/slider_dot.png")
gImg_SliderDotBlue = newPaddedImage("gfx/slider_dot_blue.png")
gImg_SliderDotGray = newPaddedImage("gfx/slider_dot_gray.png")

gImg_Monster = newPaddedImage("gfx/monster1/1_front_attack_1.png")

gImg_clock_hand = newPaddedImage("gfx/clock_hand.png")

gImg_smoke = newPaddedImage("gfx/smoke.png")
gParticleSystemStepMe = {}


function RegisterParticleSystem (ps,lifetime) 
	gParticleSystemStepMe[ps] = true
	if (lifetime) then 
		InvokeLater(function () 
			ps:stop() 
			ps:reset()
			gParticleSystemStepMe[ps] = nil
			end,lifetime)
	end
end

gParticleBufSize = 15
gParticleBufSizeBig = gParticleBufSize*3
local pi = math.pi
function MakePS_Smoke ()
	local ps = love.graphics.newParticleSystem(gImg_smoke, 100)
	RegisterParticleSystem(ps)
	ps:setBufferSize(gParticleBufSize)
	ps:setColor(200, 200, 200, 255, 20, 20, 20, 255)
	ps:setEmissionRate(10)
	ps:setLifetime(-1) -- -1=forever
	ps:setParticleLife(2,4)
	ps:setPosition(55, 25)
	ps:setSpeed(50,100)
	ps:setDirection(-0.5*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(0.1*pi)
	--~ ps:setRadialAcceleration(0)
	--~ ps:setTangentialAcceleration(0)
	--~ ps:setSpin(300, 800)
	ps:start()
	return ps
end

function MakePS_SmokeShort ()
	local ps = love.graphics.newParticleSystem(gImg_smoke, 100)
	RegisterParticleSystem(ps,2000)
	ps:setBufferSize(gParticleBufSize)
	ps:setColor(200, 200, 200, 255, 20, 20, 20, 255)
	ps:setEmissionRate(5)
	ps:setLifetime(1) -- -1=forever
	ps:setParticleLife(0.5,1)
	ps:setPosition(0,0)
	ps:setSpeed(50,100)
	ps:setDirection(-0.5*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(0.2*pi)
	--~ ps:setRadialAcceleration(0)
	--~ ps:setTangentialAcceleration(0)
	--~ ps:setSpin(300, 800)
	ps:start()
	return ps
end

gImg_burn = newPaddedImage("gfx/burn.png")

function MakePS_Burn ()
	local ps = love.graphics.newParticleSystem(gImg_burn, 100)
	RegisterParticleSystem(ps)
	ps:setBufferSize(gParticleBufSize)
	ps:setColor(255, 100, 0, 255, 255, 255, 0, 0)
	ps:setEmissionRate(10)
	ps:setLifetime(-1) -- -1=forever
	ps:setParticleLife(1,4)
	ps:setPosition(65, 35)
	ps:setSpeed(20,30)
	ps:setDirection(-0.5*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(0.2*pi)
	--~ ps:setRadialAcceleration(0)
	--~ ps:setTangentialAcceleration(0)
	--~ ps:setSpin(300, 800)
	ps:start()
	return ps
end


function MakePS_BurnShort ()
	local ps = love.graphics.newParticleSystem(gImg_burn, 100)
	RegisterParticleSystem(ps,2000)
	ps:setBufferSize(gParticleBufSize)
	ps:setColor(255, 100, 0, 155, 
				255, 255, 0, 0)
	ps:setEmissionRate(5)
	ps:setLifetime(1) -- -1=forever
	ps:setParticleLife(0.5,1)
	ps:setPosition(0, 0)
	ps:setSpeed(20,30)
	ps:setDirection(-0.5*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(0.2*pi)
	--~ ps:setRadialAcceleration(0)
	--~ ps:setTangentialAcceleration(0)
	--~ ps:setSpin(300, 800)
	ps:start()
	return ps
end

gGfxZeroOrigin = {}
function SetGfxZeroOrigin (gfx) gGfxZeroOrigin[gfx] = true end
function GetGfxZeroOrigin (gfx) return gGfxZeroOrigin[gfx] end

function MakePS_FireBall ()
	local ps = love.graphics.newParticleSystem(gImg_burn, 100)
	RegisterParticleSystem(ps,5000)
	ps:setBufferSize(gParticleBufSize)
	ps:setColor(255, 100, 0, 210, 
				255, 255, 0, 0)
	ps:setEmissionRate(50)
	ps:setLifetime(-1) -- -1=forever
	ps:setParticleLife(1,4)
	--~ ps:setPosition(65, 35)
	ps:setParticleLife(0.1,0.3)
	ps:setSpeed(20,120)
	ps:setDirection(-0.5*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(0.1*pi)
	--~ ps:setRadialAcceleration(0)
	--~ ps:setTangentialAcceleration(0)
	--~ ps:setSpin(pi,pi*2)
	ps:start()
	SetGfxZeroOrigin(ps)
	return ps
end


function MakePS_Firecircle ()
	local ps = love.graphics.newParticleSystem(gImg_burn, 100)
	RegisterParticleSystem(ps,5000)
	ps:setBufferSize(gParticleBufSizeBig)
	ps:setColor(255, 100, 0, 255, 255, 255, 0, 0)
	ps:setEmissionRate(300)
	ps:setLifetime(0.5) -- -1=forever
	ps:setParticleLife(0,1)
	ps:setPosition(0,0)
	ps:setSpeed(80)
	ps:setDirection(0*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(2*pi)
	--ps:setTangentialAcceleration(50)
	ps:setRadialAcceleration(30)
	--ps:setSpin(300, 800)
	ps:start()
	return ps
end

function MakePS_Dustcircle ()
	local ps = love.graphics.newParticleSystem(gImg_smoke, 100)
	RegisterParticleSystem(ps,5000)
	ps:setBufferSize(gParticleBufSizeBig)
	ps:setColor(200, 200, 200, 155, 
				20, 20, 20, 55)
	ps:setEmissionRate(300)
	ps:setLifetime(0.5) -- -1=forever
	ps:setParticleLife(0.5,1)
	ps:setPosition(0,0)
	ps:setSpeed(110)
	ps:setDirection(0*pi)
	--~ ps:setSize(1, 2)
	ps:setSpread(2*pi)
	--ps:setTangentialAcceleration(50)
	--~ ps:setRadialAcceleration(30)
	ps:setSpin(pi,2*pi)
	ps:start()
	
	return ps
end

clock_hand = newPaddedImage("gfx/clock_hand.png")
gImgTestDot = newPaddedImage("gfx/testdot.png")

gImgFireBall = gImgTestDot

function MyImageWrapMirror (img) return MyImageWrap(img,true) end
function MyImageWrap (img,bMirror)
	local w,h = getGfxSourceSize(img)
	local mx = bMirror and -1 or 1
	local ox = w/2
	local oy = h/2
	return {
		MyDraw = function (self,x,y,r,sx,sy) 
			love.graphics.draw(img				,x-mx*ox*sx,y-oy*sy,r,mx*sx,sy)
			--~ love.graphics.draw(gImgTestDot		,x,y,r,1,1)
		end}
end

gImgMonster1 = {
	n={		MyImageWrap(newPaddedImage("gfx/monster1/1_back_go_1.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_back_stand.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_back_go_2.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_back_stand.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_attack_1.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_attack_2.png")),
	},
	e={		MyImageWrap(newPaddedImage("gfx/monster1/1_front_go_1.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_stand.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_go_2.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_stand.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_attack_1.png")),
			MyImageWrap(newPaddedImage("gfx/monster1/1_front_attack_2.png")),
	},
	w={		MyImageWrapMirror(newPaddedImage("gfx/monster1/1_back_go_1.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_back_stand.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_back_go_2.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_back_stand.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_attack_1.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_attack_2.png")),
	},
	s={		MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_go_1.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_stand.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_go_2.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_stand.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_attack_1.png")),
			MyImageWrapMirror(newPaddedImage("gfx/monster1/1_front_attack_2.png")),
	},
}
