
cQueue = CreateClass()

function cQueue:init()
	self:removeAll()
end

function cQueue:isEmpty()
	return self.headIndex == nil
end

function cQueue:removeAll()
	self.queue = {}
	self.headIndex = nil
	self.nextIndex = 1
end

function cQueue:popHead()
	if self:isEmpty() then 
		return nil 
	else
		local o = self.queue[self.headIndex]
		self.queue[self.headIndex] = nil
		self.headIndex = self.headIndex + 1
		
		if self.headIndex == self.nextIndex then
			self.headIndex = nil
			self.nextIndex = 1
		end
		
		return o
	end
end

function cQueue:pushTail(sound)
	self.queue[self.nextIndex] = sound
	
	if self.headIndex == nil then
		self.headIndex = self.nextIndex
	end
	
	self.nextIndex = self.nextIndex + 1
end
