
cTimeDisplay = CreateClass()

function cTimeDisplay:init()
	self.timeupSound1 = nil
	self.timeupSound2 = nil
end

function cTimeDisplay:step()
	
end

gTimeRelative = 0
gDurationMonsterMode = 60*1000

function cTimeDisplay:draw()
	completeScreenOnly()

	--~ gStateStartT_Menu = gMyTicks
	--~ gStateStartT_Monster = gMyTicks

	-- set the time and year
	local year_start = 2010
	local year_end = 2070
	local year = math.min(year_end,(math.floor((gMyTicks-gStateStartT_Menu)/1000))+year_start)
	
	if self.timeupSound1 == nil and year > year_end - 10 then
		print("hurry up")
		self.timeupSound1 = love.audio.newSource("snd/sfx_timeup_1.ogg", "static")
		love.audio.play(self.timeupSound1)
	end
	
	if self.timeupSound2 == nil and year > year_end - 4 then
		print("too late")
		self.timeupSound2 = love.audio.newSource("snd/sfx_timeup_2.ogg", "static")
		love.audio.play(self.timeupSound2)
	end

	
	
	gTimeRelative = math.max(0,math.min(1,(year-year_start)/(year_end-year_start)))

	if year >= year_end and (not gBuildModeFinishDone) then
		gBuildModeFinishDone = true
		buildModeFinished()
	end
	
	-- print the date
	love.graphics.setColor(0,0,0)
	love.graphics.setFont(22)
	
	if (gStateStartT_Monster) then 
		local timeleft = gDurationMonsterMode - (gMyTicks-gStateStartT_Monster)
		gTimeRelative = math.max(0,math.min(1,(gMyTicks-gStateStartT_Monster)/gDurationMonsterMode))
		love.graphics.print(math.floor(math.max(0,timeleft)/1000).."s",485,468)
		
		if (timeleft <= 0) then
			switchState(kState_GameOver)
		end
	else
		love.graphics.print(math.min(year_end, year),485,468)
	end

	--draw the hour glass
	--~ love.graphics.setLineStyle("smooth")
	--~ love.graphics.setLineWidth(30)
	--~ if year < 2070 then
		--~ love.graphics.line(515,310*(60-gTime*-1/2)/60,515,486)
		--~ else 
		--~ love.graphics.line(515,486,515,486)
	--~ end
	-- draw the clock hand
	--~ if year < 2070 then
		--~ love.graphics.draw(gImg_clock_hand, 514, 259, -pi/2+gTime/60*2*pi, 20, 5, 0, 0)
		--~ else
		--~ love.graphics.draw(gImg_clock_hand, 514, 259, -pi/2, 20, 5, 0, 0)
	--~ end
end


