


------------------------- menu ------------------
gState_Draw[kState_Monster] = function()
	gMap1:draw()
	gMap2:draw()
	
	love.graphics.draw(gImgGui_Destroy,0,0)
	
	DrawTimeCircle(gScreenW/2,gScreenH/2,gTimeRelative,true)
	
	love.graphics.setFont(30)
	
	local dmg_postfix = "M Euro"
	
	completeScreenOnly()
	love.graphics.setColor(0,0,0,255)
	if gControllImage then simpleDraw(gControllImage, 0, 0) end
	
	love.graphics.print(gMonster2.points_casualties, 750, 80)
	love.graphics.print(gMonster2.points_damages..dmg_postfix, 750, 138)

	love.graphics.print(gMonster1.points_casualties, 238, 616)
	love.graphics.print(gMonster1.points_damages..dmg_postfix, 238, 674)
	love.graphics.setColor(255,255,255,255)
	
	gTimeDisplay:draw()
end

gState_Update[kState_Monster] = function()
	gMap1:step()
	gMap2:step()
	
	gMonster1:MonsterStep({"a","d","w"})
	gMonster2:MonsterStep({"left","right","up"})
end

gState_Leave[kState_Monster] = function()
	gControllImage = nil
end

gState_Enter[kState_Monster] = function()
	gStateStartT_Monster = gMyTicks
	gSoundQueue:stopAll()
	gSoundQueue:queueSound("snd/mx_intro_combat.ogg")
	gSoundQueue:queueSound("snd/mx_combat_music.ogg")

	switchMapPositions(gMap1, gMap2)

	local res = gMap1:getTypeStats(kBuildingType_Residence)
	local ind = gMap1:getTypeStats(kBuildingType_Industry)
	local com = gMap1:getTypeStats(kBuildingType_Commerce)

	gMonster1 = CreateClassInstance(cMonster,gMap2, res,ind,com)
	gMap2:addMonster(gMonster1)
	
	local res = gMap2:getTypeStats(kBuildingType_Residence)
	local ind = gMap2:getTypeStats(kBuildingType_Industry)
	local com = gMap2:getTypeStats(kBuildingType_Commerce)
	
	gMonster2 = CreateClassInstance(cMonster,gMap1, res,ind,com)
	gMap1:addMonster(gMonster2)
	
	gControllImage = gImg_Schild2Screen
	InvokeLater(function ()
					gControllImage = nil
				end, 5 * 1000)	
end

gState_MousePressed[kState_Monster] = function(x,y,button)
	
end

gState_KeyPressed[kState_Monster] = function(key, unicode)
	if key == "m" then switchState(kState_GameOver) end
end
